using MVR.FileManagementSecure;
using UnityEngine.UI;

namespace CheesyFX
{
    public class JSONStorableDirectory : JSONStorableUrl
    {
        public JSONStorableDirectory(string paramName, string startingValue, SetStringCallback callback, string suggestPath,
            string filter = null, bool forceCallbackOnSet = true)
            : base(paramName, startingValue, callback, filter, suggestPath, forceCallbackOnSet)
        {
            
        }

        public void RegisterFileBrowseButton(Button button)
        {
            fileBrowseButton = button;
        }

        public new Button fileBrowseButton
        {
            get { return _fileBrowseButton; }
            set
            {
                if (_fileBrowseButton == value)
                    return;
                if (_fileBrowseButton != null)
                    _fileBrowseButton.onClick.RemoveListener(FileBrowse);
                _fileBrowseButton = value;
                if (_fileBrowseButton == null)
                    return;
                _fileBrowseButton.onClick.AddListener(FileBrowse);
            }
        }
        
        public new void FileBrowse()
        {
            if (beginBrowseCallback != null)
                beginBrowseCallback();
            if (beginBrowseWithObjectCallback != null)
                beginBrowseWithObjectCallback(this);
            if (SuperController.singleton == null)
                return;
            if (suggestedPathGroup != null)
                suggestedPathGroups.TryGetValue(suggestedPathGroup, out _activeSuggestedPath);
            if (string.IsNullOrEmpty(_activeSuggestedPath))
            {
                _activeSuggestedPath = _suggestedPath;
                ReplaceSuggestedPathGroupPathWithActivePath();
            }
            else if (!FileManagerSecure.DirectoryExists(this._activeSuggestedPath))
            {
                _activeSuggestedPath = _suggestedPath;
                ReplaceSuggestedPathGroupPathWithActivePath();
            }
            // SuperController.singleton.GetMediaPathDialog(SetFilePathBrowseCallback, this._filter, this._activeSuggestedPath, this.allowFullComputerBrowse, this.showDirs, fileRemovePrefix: this.fileRemovePrefix, hideExtenstion: this.hideExtension, shortCuts: this.shortCuts, showInstallFolderInDirectoryList: this.allowBrowseAboveSuggestedPath);
            SuperController.singleton.GetDirectoryPathDialog(path => SetFilePathBrowseCallback(path, true), _activeSuggestedPath);
            
        }
    }
    
    // public class JSONStorableActionDirectoryPath : JSONStorableActionPresetFilePath
    // {
    //     protected JSONStorableDirectory url;
    //     public string name;
    //     public PresetFilePathActionCallback actionCallback;
    //     public JSONStorable storable;
    //
    //     public JSONStorableActionDirectoryPath(
    //         string n,
    //         JSONStorableActionPresetFilePath.PresetFilePathActionCallback callback,
    //         JSONStorableDirectory urlJSON) : base(n, callback, urlJSON)
    //     {
    //         name = n;
    //         actionCallback = callback;
    //         url = urlJSON;
    //     }
    //
    //     public new void Browse(JSONStorableString.SetStringCallback callback)
    //     {
    //         if (url == null)
    //             return;
    //         url.setCallbackFunction = callback;
    //         url.DirectoryBrowse();
    //     }
    //
    //     // public delegate void PresetFilePathActionCallback(string path);
    // }
}